com.io7m.jregions.core.parameterized.volumes

## Class PVolumeBI<S>

- java.lang.Object
- - com.io7m.jregions.core.parameterized.volumes.PVolumeBI<S>

- Type Parameters:
    `S` - A phantom type parameter indicating the coordinate space of the volume
  All Implemented Interfaces:
    PVolumeBIType<S>, VolumeSizeValuesBIType, VolumeValuesBIType

      @Generated(value={"Immutables.generator","PVolumeBIType<S>"})
      public final class PVolumeBI<S>
      extends Object
      implements PVolumeBIType<S>

  A volume with `BigInteger` coordinates.

  The coordinates of the area are given in half-closed form. That is, `minimumX()` refers to the minimum inclusive value on the X axis, and `maximumX()` refers to the maximum exclusive value on the X axis. Likewise for the Y and Z axes.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `PVolumeBI.Builder<S>` Builds instances of type `PVolumeBI`.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static <S> PVolumeBI.Builder<S>` | `builder()` Creates a builder for `PVolumeBI`.
    `boolean` | `equals(Object another)` This instance is equal to all instances of `PVolumeBI` that have equal attribute values.
    `int` | `hashCode()` Computes a hash code from attributes: `minimumX`, `maximumX`, `minimumY`, `maximumY`, `minimumZ`, `maximumZ`.
    `BigInteger` | `maximumX()`
    `BigInteger` | `maximumY()`
    `BigInteger` | `maximumZ()`
    `BigInteger` | `minimumX()`
    `BigInteger` | `minimumY()`
    `BigInteger` | `minimumZ()`
    `static <S> PVolumeBI<S>` | `of(BigInteger minimumX, BigInteger maximumX, BigInteger minimumY, BigInteger maximumY, BigInteger minimumZ, BigInteger maximumZ)` Construct a new immutable `PVolumeBI` instance.
    `String` | `toString()` Prints the immutable value `PVolumeBI` with attribute values.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.io7m.jregions.core.parameterized.volumes.PVolumeBIType

      `checkPreconditions`

    - ### Methods inherited from interface com.io7m.jregions.core.unparameterized.volumes.VolumeValuesBIType

      `sizeX, sizeY, sizeZ`

- - ### Method Detail

    - #### minimumX

          public BigInteger minimumX()

      Specified by:
        `minimumX` in interface `PVolumeBIType<S>`
      Specified by:
        `minimumX` in interface `VolumeValuesBIType`
      Returns:
        The value of the `minimumX` attribute

    - #### maximumX

          public BigInteger maximumX()

      Specified by:
        `maximumX` in interface `PVolumeBIType<S>`
      Specified by:
        `maximumX` in interface `VolumeValuesBIType`
      Returns:
        The value of the `maximumX` attribute

    - #### minimumY

          public BigInteger minimumY()

      Specified by:
        `minimumY` in interface `PVolumeBIType<S>`
      Specified by:
        `minimumY` in interface `VolumeValuesBIType`
      Returns:
        The value of the `minimumY` attribute

    - #### maximumY

          public BigInteger maximumY()

      Specified by:
        `maximumY` in interface `PVolumeBIType<S>`
      Specified by:
        `maximumY` in interface `VolumeValuesBIType`
      Returns:
        The value of the `maximumY` attribute

    - #### minimumZ

          public BigInteger minimumZ()

      Specified by:
        `minimumZ` in interface `PVolumeBIType<S>`
      Specified by:
        `minimumZ` in interface `VolumeValuesBIType`
      Returns:
        The value of the `minimumZ` attribute

    - #### maximumZ

          public BigInteger maximumZ()

      Specified by:
        `maximumZ` in interface `PVolumeBIType<S>`
      Specified by:
        `maximumZ` in interface `VolumeValuesBIType`
      Returns:
        The value of the `maximumZ` attribute

    - #### equals

          public boolean equals(Object another)

      This instance is equal to all instances of `PVolumeBI` that have equal attribute values.
      Overrides:
        `equals` in class `Object`
      Returns:
        `true` if `this` is equal to `another` instance

    - #### hashCode

          public int hashCode()

      Computes a hash code from attributes: `minimumX`, `maximumX`, `minimumY`, `maximumY`, `minimumZ`, `maximumZ`.
      Overrides:
        `hashCode` in class `Object`
      Returns:
        hashCode value

    - #### toString

          public String toString()

      Prints the immutable value `PVolumeBI` with attribute values.
      Overrides:
        `toString` in class `Object`
      Returns:
        A string representation of the value

    - #### of

          public static <S> PVolumeBI<S> of(BigInteger minimumX,
                                            BigInteger maximumX,
                                            BigInteger minimumY,
                                            BigInteger maximumY,
                                            BigInteger minimumZ,
                                            BigInteger maximumZ)

      Construct a new immutable `PVolumeBI` instance.
      Parameters:
        `minimumX` - The value for the `minimumX` attribute
        `maximumX` - The value for the `maximumX` attribute
        `minimumY` - The value for the `minimumY` attribute
        `maximumY` - The value for the `maximumY` attribute
        `minimumZ` - The value for the `minimumZ` attribute
        `maximumZ` - The value for the `maximumZ` attribute
      Returns:
        An immutable PVolumeBI instance

    - #### builder

          public static <S> PVolumeBI.Builder<S> builder()

      Creates a builder for `PVolumeBI`.
      Type Parameters:
        `S` - generic parameter S
      Returns:
        A new PVolumeBI builder

Copyright © 2017 <code@io7m.com> http://io7m.com